# Draughts from ZX Computing Summer 1982.
# Ported to the ZX81 by
# - changing chr$ 9 to 8
# - equality gives -1 on ZX80, 1 on ZX81
# - rnd gives number between 0 and 1
# - corrections, enhancements and some error checking added
# - new capture checks at 7000,7100

# convert to p file:
./zce -qc adapts/draughts.bas -s adapts/draughts.p

 1 rem Originally from ZX Computing Summer 1982 for the ZX80.
   goto 9000

# user input entry point; first display board
 2 for z=6 to 40
# promote to kings (36 was 37 - probably bug)
 4 if z>36 and a(z)=1 then let a(z)=2
   if z<10 and a(z)=-1 then let a(z)=-2
# inverted W,O,space,X,U
   if a(z)=-2 then let a(z)=188
   if a(z)=-1 then let a(z)=180
   if a(z)=0  then let a(z)=128
   if a(z)=1  then let a(z)=189
   if a(z)=2  then let a(z)=186
26 next z

35 cls

# The computer plays at this side of the board
39 print "ZX81  ";SI
   print ,"   ABCDEFGH"
   print ,"  ";e$;e$;e$;e$;e$;e$;e$;e$;e$;e$

   print ," 1";e$;" ";chr$(a(40));" ";chr$(a(39));" ";chr$(a(38));" ";chr$(a(37));e$
   print ," 2";e$;chr$(a(36));" ";chr$(a(35));" ";chr$(a(34));" ";chr$(a(33));" ";e$
   print ," 3";e$;" ";chr$(a(31));" ";chr$(a(30));" ";chr$(a(29));" ";chr$(a(28));e$
   print ," 4";e$;chr$(a(27));" ";chr$(a(26));" ";chr$(a(25));" ";chr$(a(24));" ";e$
   print ," 5";e$;" ";chr$(a(22));" ";chr$(a(21));" ";chr$(a(20));" ";chr$(a(19));e$
   print ," 6";e$;chr$(a(18));" ";chr$(a(17));" ";chr$(a(16));" ";chr$(a(15));" ";e$
   print ," 7";e$;" ";chr$(a(13));" ";chr$(a(12));" ";chr$(a(11));" ";chr$(a(10));e$
   print ," 8";e$;chr$(a(9));" ";chr$(a(8));" ";chr$(a(7));" ";chr$(a(6));" ";e$

   print,"  ";e$;e$;e$;e$;e$;e$;e$;e$;e$;e$
   if cc=0 then print "HUMAN ";SM

50 for z=6 to 40
51 if a(z)=188 then let a(z)=-2
   if a(z)=180 then let a(z)=-1
   if a(z)=128 then let a(z)=0
   if a(z)=189 then let a(z)=1
   if a(z)=186 then let a(z)=2
56 next z

# there are twelve captures to make
58 if cc=1 and si=24 then print at 21,0;"I win"
   if cc=0 and si=12 then print at 21,0;"I win"
   if sm=12 then print at 21,0;"You win"
   if (cc=1 and si=24) or (cc=0 and si=12) or sm=12 then goto 9200

65 if cc=1 then goto 9400
68 print
69 print "Last to ";f$
70 print
71 print "From? (let.num.) ";
72 input d$
73 if d$="q" then stop
74 if d$="c" then goto 9350
75 gosub 9300
76 if d=0 then goto 70
77 let c=d
78 print d$;" to? ";
79 input d$
80 if d$="q" then stop
81 gosub 9300
82 if d=0 then goto 70
83 let b=d
84 let f$=d$

100 if a(c)=0 or a(b)<>0 then goto 70
    if b-c=10 and a(b-5)>=0 then goto 70
    if b-c=10 then let a(b-5)=0
    if b-c=8 and a(b-4)>=0 then goto 70
    if b-c=8 then let a(b-4)=0
    if c-b=10 and a(c-5)>=0 then goto 70
    if c-b=10 then let a(c-5)=0
    if c-b=8 and a(c-4)>=0 then goto 70
    if c-b=8 then let a(c-4)=0
# a capture by the human
    if abs(c-b)=10 or abs(c-b)=8 then let sm=sm+1

150 let a(b)=a(c)
    let a(c)=0
    let u$=""

170 if abs(c-b)<>10 and abs(c-b)<>8 then goto 200
    print "Multi?"
    input u$
    if u$="q" then stop
    if u$="y" then goto 2

200 gosub 2000
210 goto 2

# entry point for computer
# check possibilities for normal stones otherwise kings
2000 for z=6 to 40
2005 gosub 7100
2010 if p>0 then return
2015 next z

# nothing to be captured - random move intelligent
# check if move is possible without being captured;
# then check moves with capture
# z will be in the range of 6-40
4005 let kk=0
     let u=0
4010 let z=6+int(rnd*35)
4012 let k=0
4014 if u>199 then let kk=kk+1
4016 let u=u+1
4018 if a(z)<0 and a(z-4)=0 then let k=1
4020 if k=0 and a(z)<0 and a(z-5)=0 then let k=2
4022 if k=0 and z<=36 and a(z)=-2 and a(z+4)=0 then let k=-7
# z-8>=6, so
4024 if z<14 then goto 4028
4026 if k=1 and u<200 and a(z-8)=1 then goto 4010
# z-10>=6, so
4028 if z<16 then goto 4040
4030 if k=2 and u<200 and a(z-10)=1 then goto 4010

4040 if k=0 and kk<350 then goto 4010
# if unable to find a move surrender
4042 if k=0 then let sm=12
4044 if k=0 then return
4048 let a(z-(3+k))=a(z)
4050 let a(z)=0
4052 return

# The board: going diagonally gives changes of 4 or 5
# thanks to the missing 14, 23, and 32
#
# .. 40 .. 39 .. 38 .. 37
# 36 .. 35 .. 34 .. 33 ..
# .. 31 .. 30 .. 29 .. 28
# 27 .. 26 .. 25 .. 24 ..
# .. 22 .. 21 .. 20 .. 19
# 18 .. 17 .. 16 .. 15 ..
# .. 13 .. 12 .. 11 .. 10
# 09 .. 08 .. 07 .. 06 ..

# check for capture
# z-10>=6, so
7000 if z<16 then goto 7004
7002 if a(z)<0 and (a(z-5)=1 or a(z-5)=2) and a(z-10)=0 then goto 7030
# z-8>=6, so
7004 if z<14 then goto 7008
7006 if a(z)<0 and (a(z-4)=1 or a(z-4)=2) and a(z-8)=0 then goto 7035
# z+8<=40, so
7008 if z>32 then goto 7012
7010 if a(z)=-2 and (a(z+4)=1 or a(z+4)=2) and a(z+8)=0 then goto 7040
# z+10<=40, so
7012 if z>30 then goto 7016
7014 if a(z)=-2 and (a(z+5)=1 or a(z+5)=2) and a(z+10)=0 then goto 7045
7016 return

7030 let a(z-5)=0
7031 let a(z-10)=a(z)
7032 let zn=z-10
7033 goto 7050

7035 let a(z-4)=0
7036 let a(z-8)=a(z)
7037 let zn=z-8
7038 goto 7050

7040 let a(z+4)=0
7041 let a(z+8)=a(z)
7042 let zn=z+8
7043 goto 7050

7045 let a(z+5)=0
7046 let a(z+10)=a(z)
7047 let zn=z+10

7050 let pp=1
7052 let a(z)=0
7053 let z=zn
7055 return

7100 let p=0
7102 let pp=0
7104 gosub 7000
7106 if pp=0 then return
7108 let p=p+1
7110 let si=si+1
7112 if z>9 then goto 7102
7114 return

# initialize
9000 fast
9002 dim a(45)

# the chr$ 8s are outside the board, never accessed
# if z checks are ok
# computer stones are negative, human stones are positive
9005 for z=1 to 45
9010 if z<6 then let a(z)=8
     if z>5 and z<19 then let a(z)=1
     if z>18 and z<28 then let a(z)=0
     if z>27 and z<41 then let a(z)=-1
     if z>40 then let a(z)=8
9060 next z

# character 8 is character 9 (shift A) on ZX80
9070 let e$=chr$(8)
9072 let a(14)=8
9074 let a(23)=8
9076 let a(32)=8
9078 let u$=""
9080 let p=0
9082 let f$="--"
9084 rand
9086 let si=0
9088 let sm=0
9092 let cc=0
9094 if cc=1 then goto 2

9096 print "Do you want first move? (Y/N)"
9098 input j$
9100 if j$="q" then stop
9102 if not j$="y" then gosub 2000
9104 goto 2

9200 rem $s
     stop

# convert let.num. position to number
9300 let d = 40*(d$="B1")+39*(d$="D1")+38*(d$="F1")+37*(d$="H1")+36*(d$="A2")+35*(d$="C2")+34*(d$="E2")+33*(d$="G2")+31*(d$="B3")+30*(d$="D3")+29*(d$="F3")+28*(d$="H3")+27*(d$="A4")+26*(d$="C4")+25*(d$="E4")+24*(d$="G4")+22*(d$="B5")+21*(d$="D5")+20*(d$="F5")+19*(d$="H5")+18*(d$="A6")+17*(d$="C6")+16*(d$="E6")+15*(d$="G6")+13*(d$="B7")+12*(d$="D7")+11*(d$="F7")+10*(d$="H7")+9*(d$="A8")+8*(d$="C8")+7*(d$="E8")+6*(d$="G8")
9310 return

# switch to computer
9350 let si=si+sm
9352 let sm=0
9354 let cc=1

# the computer plays for the human
9400 if cc=1 then rem $s
9402 gosub 9500
9403 gosub 2000
9404 gosub 9500
9405 gosub 2000
9410 goto 2

# switch players/rotate board
9500 for z=6 to 22
9510 if z=14 then goto 9560
9520 let zz=46-z
9530 let t=a(z)
9540 let a(z)=-a(zz)
9550 let a(zz)=-t
9560 next z
9570 return
