#include <stdio.h>
#include "z80.h"
#include "sixel.h"

extern unsigned char mem[MSIZE];
extern FILE* sf;
extern unsigned int hrptr;

int sixel_output(int n, char c, int &olf)
{
	int i;

	if (olf) {
	  for (i=1; i<=olf; i++) fprintf(sf,"#9!7?~-~!7?#1\n");
	  olf = 0;
	}

	if (n > 3) {
	  return fprintf(sf,"!%d%c", n, c);
	} else {
	  for (i=0; i<n; i++) fputc(c,sf);
	}
	return n;
}

void sixel_copy()
{
	unsigned int ptr, iptr, optr1, optr2;
	unsigned char *cptr;
	int n = 0;
	int c1, c2, d;
	int i, j, jj, l, nm, no;
	int s, ps, ns;
	int caps1, caps2;

	int nj;
	int oj1, oj2;
	int np;
	int pat = 1;
	int olf = 0;

	ptr = mem[0x400c] + (mem[0x400d] << 8);
        if (mem[ptr]!=0x76) return;
	ptr++;
	cptr = mem + (mem[0x10000] << 8);

	fprintf(sf,"\n\033Pq#9~!270@~-~!7?#1\n");

	n = 1;
	ns = 0;
	l = 0;

	no = 0;

	nj = 6;
	oj1 = 0;
	oj2 = 0;

	ps = 0;

	iptr = 0;
	optr1 = 0;
	optr2 = 0;

	nm = 1;
	np = 1;
	for (;;) {
	 for (l=1; l<=np; l++) {
	  c1 = mem[ptr+iptr-optr1];
	  c2 = mem[ptr+iptr+optr2];
	  if (c2==0x76) {
	    if (ns>0) sixel_output(ns,ps,olf);
	    olf++;
	    ns = 0;
	    ps = 0;
	    no = 0;

	    if (l==np) {
	      if (n>=24) goto done;
	      n++;
	      optr1 = iptr+1;
	      ptr += optr1;
	    }

	    iptr = 0;

	    oj1 = nj;

	    if (oj2!=0) {
	      oj2 = 0;
	    } else {
	      switch (nj) {
	        case 6 : nj = 4; break;
	        case 4 : nj = 2; break;
	        case 2 : nj = 6; oj2 = 2; break;
	        default :;
	      }
	    }


	   } else {

	    caps1 = c1 & 0x80;
	    c1 &= 0x7f;
	    caps2 = c2 & 0x80;
	    c2 &= 0x7f;

	    for (i=0; i<8; i++) {
	      s = 0;

	      jj = 0;

	      for (j=0; j<6-nj; j++) {
	        d = cptr[c1*8+oj1+j];
	        if (caps1) {
	          if (!(d & (128>>i))) s += (pat<<jj);
	        } else {
	          if (d & (128>>i)) s += (pat<<jj);
	        }
	        jj++;
	      }

	      for (j=0; j<nj; j++) {
	        d = cptr[c2*8+oj2+j];
	        if (caps2) {
	          if (!(d & (128>>i))) s += (pat<<jj);
	        } else {
	          if (d & (128>>i)) s += (pat<<jj);
	        }
	        jj++;
	      }

	      s += 63;
	      if (s!=ps && ps!='\0') {
	        no += sixel_output(ns,ps,olf);
		if (no>70) { fputc('\n',sf); no=0; }
	        ns = 0;
	      }
	      ns++;
	      ps = s;
	    }
	    iptr++;
	  }
	 }
	 switch (nm) {
	   case 1 : nm=2; np=1; break;
	   case 2 : nm=3; np=2; break;
	   case 3 : nm=1; np=1; break;
	   default :;
	 }

	}

done:
	fprintf(sf,"#9!7?~-!272@\n\033\\\n");
}

/* 24*8 or 32 sixel lines of 32 bytes is 6K */
/* coordinates x = 0..255, y = 0..191 */

void hires()
{
	unsigned int ptr, ofs;
	int i, j, k, l, s, ps, ns, no;
	unsigned char msk;
	int olf = 0;

 //     sf = fopen("zx81.six","w");

	ptr = hrptr;

	fprintf(sf,"\033Pq#9~!270@~-\n");

	for (j=0; j<32; j++) {
	  fprintf(sf,"~!7?#1");
	  ps = 0;
	  ns = 0;
	  no = 0;
	  for (i=0; i<32; i++) {
	    msk = 0x80;
	    for (k=0; k<8; k++) {
	      s = 0;
	      ofs = 0;
	      for (l=0; l<6; l++) {
	        if (mem[ptr+i+ofs] & msk) s += (1 << l);
		ofs += 32;
	      }
	      s += 63;
	      if (s!=ps && ps!='\0') {
		no += sixel_output(ns, ps, olf);
		if (no>70) { fputc('\n',sf); no=0; }	        
		ns = 0;
	      }
	      ns++;
	      ps = s;
	      msk >>= 1;
	    }
	  }
	  sixel_output(ns, ps, olf);
	  fprintf(sf,"#9!7?~-\n");
	  ptr += 192;
	}

	fprintf(sf,"~!270_~-\n\033\\\n");
//	fclose(sf);
//      sf = stdout;
}

void hires_clear()
{
	unsigned int ptr;

	for (ptr=hrptr; ptr<0x4000; ptr++) mem[ptr] = 0;
}

void hires_plot(unsigned char x, unsigned char y)
{
	unsigned int ptr, bx, msk;;

	bx = x/8;
	ptr = hrptr + y*32 + bx;
	bx = x-bx*8;
	msk = 0x80 >> bx;

//	if (mem[ptr] & msk) mem[ptr] &= ~msk; else mem[ptr] |= msk;
	mem[ptr] |= msk;
}
