#define MSIZE 0x20000
#define MPSIZE 0x80

extern unsigned char mem[MSIZE], meme[MSIZE];
/* this two work on a per-k basis, so we can support 1k etc. properly */
extern unsigned char *memptr[MPSIZE], *memptre[MPSIZE];
extern int memattr[MPSIZE];
extern int ctrlcd;

#define Z80_quit  1
#define Z80_NMI   2
#define Z80_reset 3
#define Z80_load  4
#define Z80_save  5
#define Z80_log   6

#define fetch(x) (memptr[(unsigned int)(x)>>10][(x)&1023])
#define fetche(x) (memptre[(unsigned int)(x)>>10][(x)&1023])
#define fetch2(x) ((fetche((x)+1)<<16)|(fetch((x)+1)<<8)|fetch(x))

#define store(x,y) do {\
          unsigned short off=(x)&1023;\
          unsigned char page=(unsigned int)(x)>>10;\
          int attr=memattr[page];\
          if(attr){\
             memptr[page][off]=(y);\
             } else {\
             memptre[page][off]=(y);\
             }\
           } while(0)

#define store2b(x,hi,lo) do {\
          unsigned short off=(x)&1023;\
          unsigned char page=(unsigned int)(x)>>10;\
          int attr=memattr[page];\
          if(attr) { \
             memptr[page][off]=(lo);\
             memptr[page][off+1]=(hi&0x00ff);\
             memptre[page][off+1]=((hi&0xff00)>>8);\
             }\
          } while(0)

#define store2(x,y) store2b(x,(y)>>8,(y)&255)

#ifdef __GNUC__
static void inline storefunc(unsigned int ad,unsigned char b){
//   if (ad<8192) printf("%x %x\n",ad,b);
   store(ad,b);
}
#undef store
#define store(x,y) storefunc(x,y)

static void inline store2func(unsigned int ad,unsigned short b1,unsigned char b2){
   store2b(ad,b1,b2);
}
#undef store2b
#define store2b(x,hi,lo) store2func(x,hi,lo)
#endif

#define bc ((b<<8)|c)
#define de ((d<<8)|e)
#define hl ((h<<8)|l)

class z80_processor {
public:
	unsigned char a, f, b, c, d, e, h, l;
	unsigned char j;
	unsigned char r, a1, f1, b1, c1, d1, e1, h1, l1, i, iff1, iff2, im;
	unsigned int pc;
	unsigned short ix, iy, sp;
	unsigned char radjust;
	unsigned char ixoriy, new_ixoriy;
	unsigned char intsample;
	unsigned char op;
	int nmipend,intpend;
	int verbose;
	unsigned int bptr;
	unsigned char bins;

	z80_processor() : r(0), i(0), im(0), pc(0), intsample(0), nmipend(0), intpend(0), verbose(0), bins(0x76) {}
        void zero() { a=f=b=c=d=e=h=l=j=r=a1=f1=b1=c1=d1=e1=h1=l1=i=iff1=iff2=im=pc=ix=iy=sp=0; }
	void set_verbose() { verbose = 1; }
	void set_noverbose() { verbose = 0; }
	int toggle_verbose() { verbose = !verbose; return verbose; }
	int get_verbose() { return verbose; }
	void show(const int showpc=1);
	void step(const int sverbose=1);
	void run(const unsigned int newpc);
	void prepare();
	void run_ret(const unsigned int newpc);
        void breakpoint(const unsigned int ptr);
        void cancel();
};
